/********************************************************************
 * FileName:        output_mngt.h
 * Dependencies:    See INCLUDES section below
 * Processor:       MCP19111
 * Compiler:        XC8 v1.11
 * Company:         Microchip Technology, Inc.
 *
 * Software License Agreement:
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") for its PICmicro Microcontroller is intended and
 * supplied to you, the Company's customer, for use solely and
 * exclusively on Microchip PICmicro Microcontroller products. The
 * software is owned by the Company and/or its supplier, and is
 * protected under applicable copyright laws. All rights are reserved.
 * Any use in vsiolation of the foregoing restrictions may subject the
 * user to criminal sanctions under applicable laws, as well as to
 * civil liability for the breach of the terms and conditions of this
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *********************************************************************
 *
 * Version              Date        Comment
 * 1.000                05.12.2012  Initial release
 ********************************************************************/
#ifndef OUTPUT_MNGT_H
#define	OUTPUT_MNGT_H

#ifdef	__cplusplus
extern "C" {
#endif


#include "pic.h"
#include "V_DEF_MCP19111.h"
#include "pmbus_core.h"
#include "macro.h"
#define RAMP_STEP 4
#define VOUT_MAX 3840/4
#define VOUT_CODE_FROM_PMB_OVERFLOW(x) (x > VOUT_MAX)
#define VOUT_CODE_FROM_PMB(x) (x/4)
#define VOUT_GET_MANTISSA(x) (int)(*(x+1) << 8 | (*x))
#define VOUT_EN 0x80

void switchOffOutput(void);
void softStopOutput(void);
void restoreOutput(void);
void voutRampTarget(void);
void checkOutputRange(unsigned char * pmb_mem, unsigned char * reg);
void checkEnPin(void);

unsigned char m_OVCCON_target = 0;

#ifdef	__cplusplus
}
#endif

#endif	/* OUTPUT_MNGT_H */

