/********************************************************************
 * FileName:        pmbus_handler.h
 * Dependencies:    See INCLUDES section below
 * Processor:       MCP19111
 * Compiler:        XC8 v1.11
 * Company:         Microchip Technology, Inc.
 *
 * Software License Agreement:
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") for its PICmicro Microcontroller is intended and
 * supplied to you, the Company's customer, for use solely and
 * exclusively on Microchip PICmicro Microcontroller products. The
 * software is owned by the Company and/or its supplier, and is
 * protected under applicable copyright laws. All rights are reserved.
 * Any use in vsiolation of the foregoing restrictions may subject the
 * user to criminal sanctions under applicable laws, as well as to
 * civil liability for the breach of the terms and conditions of this
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *********************************************************************
 *
 * Version              Date        Comment
 * 1.000                05.12.2012  Initial release
 ********************************************************************/

#ifndef PMBUS_HANDLER_H
#define	PMBUS_HANDLER_H

#ifdef	__cplusplus
extern "C" {
#endif


    
#include "pmbus_core.h"
#include "macro.h"
#include "flash_rw.h"
#include "output_mngt.h"
#include "vin_lookup.h"

#define GET_MANTISSA(x) (int)((*(x+1) & 0x07) << 8 | (*x))
    
extern void switchOffOutput(void);
extern void softStopOutput(void);
extern void restoreOutput(void);


void pmbusHostRead(unsigned char code, unsigned char *ram_index);
void pmbusHostWrite();

#ifdef	__cplusplus
}
#endif

#endif	/* PMBUS_HANDLER_H */

