#ifndef HARDWARE_PROFILE_PIC32MX450F256_H
#define HARDWARE_PROFILE_PIC32MX450F256_H

    //#define USE_SELF_POWER_SENSE_IO
    #define tris_self_power     #error "No Defined"
    #define self_power          1

    //#define USE_USB_BUS_SENSE_IO
    #define tris_usb_bus_sense  #error "No Defined"
    #define USB_BUS_SENSE       1 

    #define APP2013TM
    #define CLOCK_FREQ 60000000
    #define Codec_WM8960

    /** LED ************************************************************/
    #define mInitAllLEDs()  ANSELBbits.ANSB9 = 0; \
                            ANSELBbits.ANSB10 = 0; \
                            ANSELBbits.ANSB12 = 0; \
                            ANSELBbits.ANSB13 = 0; \
                            mPORTBSetPinsDigitalOut(BIT_9 | BIT_10 | BIT_12 | BIT_13);
    
    #define mLED_1              LATBbits.LATB9
    #define mLED_2              LATBbits.LATB10
    #define mLED_3              LATBbits.LATB12
    #define mLED_4              LATBbits.LATB13
    
    #define mGetLED_1()         mLED_1
    #define mGetLED_2()         mLED_2
    #define mGetLED_3()         mLED_3
    #define mGetLED_4()         mLED_4

    #define mLED_1_On()         mLED_1 = 1
    #define mLED_2_On()         mLED_2 = 1
    #define mLED_3_On()         mLED_3 = 1
    #define mLED_4_On()         mLED_4 = 1
    
    #define mLED_1_Off()        mLED_1 = 0
    #define mLED_2_Off()        mLED_2 = 0
    #define mLED_3_Off()        mLED_3 = 0
    #define mLED_4_Off()        mLED_4 = 0
    
    #define mLED_1_Toggle()     mLED_1 = !mLED_1
    #define mLED_2_Toggle()     mLED_2 = !mLED_2
    #define mLED_3_Toggle()     mLED_3 = !mLED_3
    #define mLED_4_Toggle()     mLED_4 = !mLED_4
    
    /** SWITCH *********************************************************/
    #define mInitSwitch2()      mPORTDSetPinsDigitalIn(BIT_7);
    #define mInitSwitch3()      mPORTDSetPinsDigitalIn(BIT_6);
    #define mInitAllSwitches()  mInitSwitch2();mInitSwitch3();
    #define sw2                 PORTDbits.RD7
    #define sw3                 PORTDbits.RD6

    #define mInitAudioDriver()  {TRISDCLR = 0x00000100; LATDSET = 0x00000100; }
    #define mAudioDriverON()	LATDCLR = 0x00000100;
    #define mAudioDriverOFF()	LATDSET = 0x00000100;

    /** POT ************************************************************/
    #define mInitPOT() { \
                OpenADC10(ADC_MODULE_ON | ADC_IDLE_CONTINUE | ADC_FORMAT_INTG16 | ADC_CLK_MANUAL | ADC_AUTO_SAMPLING_ON | ADC_SAMP_OFF, \
                ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_OFF | ADC_SAMPLES_PER_INT_1 | ADC_ALT_BUF_OFF | ADC_ALT_INPUT_OFF, \
                ADC_SAMPLE_TIME_31 | ADC_CONV_CLK_SYSTEM | ADC_CONV_CLK_32Tcy, \
                ENABLE_AN11_ANA, SKIP_SCAN_ALL); \
                SetChanADC10(ADC_CH0_POS_SAMPLEA_AN11 | ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEB_AN0 | ADC_CH0_NEG_SAMPLEB_NVREF); }
                
    /** I/O pin definitions ********************************************/
    #define INPUT_PIN 1
    #define OUTPUT_PIN 0
    #ifdef AUDIO_SAMPLING_FREQUENCY_48000
        #define NO_OF_SAMPLES_IN_A_USB_FRAME 48
        #define PWM_PERIOD	(CLOCK_FREQ/48000)-1
    #elif defined AUDIO_SAMPLING_FREQUENCY_32000
        #define NO_OF_SAMPLES_IN_A_USB_FRAME 32
        #define PWM_PERIOD	(CLOCK_FREQ/32000)-1
    #elif defined AUDIO_SAMPLING_FREQUENCY_44100
        #define NO_OF_SAMPLES_IN_A_USB_FRAME 44
        #define PWM_PERIOD	(CLOCK_FREQ/44100)-1
    #endif
    #define mInitAudioDriver()  {TRISDCLR = 0x00000100; LATDSET = 0x00000100; }
    #define mAudioDriverON()	LATDCLR = 0x00000100;
    #define mAudioDriverOFF()	LATDSET = 0x00000100;

    /****** PWM Intialization*******************************************/
    // configure RD0 as output for PWM
    // PWM mode, Single output, Active High
    #define mInitPWM()  { \
                        TRISDCLR = 0x00000001;\
    			OC1R = 0;\
    			OC1CON = 0x0000;\
    			OC1RS = 0;\
    			OC1CON = 0x0006;\
    			OC1CONSET = 0x8000;\
                        }
    #define DUTY_CYCLE OC1RS  // Duty Cycle register of the PWM Peripheral.
    #define MULTIPLY_FACTOR 4 // The Audio received from the USB host is 8 bits/Sample.
    #define mInitTimerInterrupt() { INTEnableSystemMultiVectoredInt();\
    								INTEnableInterrupts;\
    								  }
    #define mInitTimer() 		  { OpenTimer2(T2_ON | T2_SOURCE_INT | T2_PS_1_1,\
                                    PWM_PERIOD);\
    								ConfigIntTimer2(T2_INT_OFF | T2_INT_PRIOR_7);\
    							  }
    #define mStartAudio()  {EnableIntT2;} // unmask timer 2 interrupt
    #define mStopAudio()   {DisableIntT2;}// mask timer 2 interrupt
#endif  //HARDWARE_PROFILE_PIC32MX450F256_H
